var objTxtbgfixerBrowser = {

	onload: function (ndTarget)
	{
		if ( ! gPrefService.prefHasUserValue('txtbgfixer.enabled') )
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );

		if ( ! gPrefService.getBoolPref('txtbgfixer.enabled') ||
			! gPrefService.getBoolPref('browser.display.use_document_colors') ) return;

		var ndDocument = ndTarget.originalTarget;
		var ndBody = ndDocument.getElementsByTagName("body")[0]; if (ndBody==null) return;
		var sBgcolor = ndBody.getAttribute("bgcolor");
		var sTxtcolor = ndBody.getAttribute("text");

		if ( sBgcolor && ! sTxtcolor ) {
			if ( sBgcolor != "#000000" ) ndBody.setAttribute("text", "#000000");
		}
		else if ( ! sBgcolor && sTxtcolor ) {
			if (sTxtcolor != "#FFFFFF" ) ndBody.setAttribute("bgcolor", "#FFFFFF");
		}
		else if ( ! sBgcolor && !sTxtcolor ) {
			if ( ndTD = ndDocument.getElementsByTagName("td") ) {
				for ( i = 0; i < ndTD.length; ++i ) {
					if ( ndTD[i].getAttribute("bgcolor") ) {
						ndBody.setAttribute("text", "#000000");
						ndBody.setAttribute("bgcolor", "#FFFFFF");
						break;
					}
				}
			}
		}

		if ( ndDocument.getElementsByTagName("form").length > 0 ) {
			this.fixElementStyle (ndDocument, "input");
			this.fixElementStyle (ndDocument, "textarea");
			this.fixElementStyle (ndDocument, "select");
			this.fixElementStyle (ndDocument, "option");
		}

		if ( ndDocument.links.length > 0 && ndDocument.styleSheets.length > 0 ) {
			sLinkcolor = ndDocument.defaultView.getComputedStyle(ndDocument.links[0],'').getPropertyValue("color");

			for ( i = 0; i < ndDocument.styleSheets[0].cssRules.length; ++i ) {
				if (ndDocument.styleSheets[0].cssRules[i].selectorText.indexOf("a:visited") != -1 ) {
					if ( (sVlinkcolor=ndDocument.styleSheets[0].cssRules[i].style.color) != "" ) {
						if ( sLinkcolor == sVlinkcolor ) {
							sVlinkcolor = sVlinkcolor.replace("rgb(","").replace(")","");
							sVlinkcolorRGB = sVlinkcolor.split(",");
							for ( j = 0; j < 3; j++ ) {
								sVlinkcolorRGB[j] -= 51;
								if (sVlinkcolorRGB[j] < 0) sVlinkcolorRGB[j] = 0;
							}
							ndDocument.styleSheets[0].cssRules[i].style.color = "rgb(" +
								sVlinkcolorRGB[0] + ", " + sVlinkcolorRGB[1] + ", " + sVlinkcolorRGB[2] + ")";
							break;
						}
					}
				}
			}
		}

	},

	fixElementStyle: function ( ndDocument, tagname ) {
		var ndElements, sElementBgcolor, sElementColor;

		if ( ndElements = ndDocument.getElementsByTagName(tagname) ) {
			for ( i = 0; i < ndElements.length; ++i ) {
				if ( tagname == "input" && (
					ndElements[i].getAttribute("type") == "image" ||
					ndElements[i].getAttribute("type") == "submit" )) continue;

				sElementColor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("color");
				sElementBgcolor = ndDocument.defaultView.getComputedStyle(ndElements[i],'').getPropertyValue("background");

				if ( sElementBgcolor=="" && sElementColor=="rgb(0, 0, 0)" )
					ndElements[i].setAttribute("style", ndElements[i].getAttribute("style") + "; background: #FFFFFF;");
			}
		}
	},


	toggle: function()
	{
		if ( gPrefService.getBoolPref('txtbgfixer.enabled') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer off" );
		}
		else if ( gPrefService.getBoolPref('browser.display.use_document_colors') ) {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', false );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', false );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer on" );
		}
		else {
			gPrefService.setBoolPref( 'txtbgfixer.enabled', true );
			gPrefService.setBoolPref( 'browser.display.use_document_colors', true );
			window._content.document.location.reload();
			this.setstatustxt( "Txt-Bgcolor Fixer forcing user-defined colors" );
		}
	},


	setstatustxt: function (msg)
	{
		document.getElementById("statusbar-display").label = msg;
	}


}

function txtbgfixerLoadWindow (e) {
	objTxtbgfixerBrowser.onload (e);
}

window.addEventListener ("load", txtbgfixerLoadWindow, true);
